from optimal_u.hex3_gen_u_optim import load_data

parameters = {}
parameters['T0'] = [60, 10]  # C
parameters['w0'] = [105, 25]  # kW/K
parameters['wh1'] = [40, 10]  # kW/K
parameters['wh2'] = [50, 10]  # kW/K
parameters['wh3'] = [30, 10]  # kW/K
parameters['Th1'] = [150, 30]  # C
parameters['Th2'] = [150, 30]  # C
parameters['Th3'] = [150, 30]  # C
parameters['UA1'] = [65, 15]  # kW/K
parameters['UA2'] = [80, 10]  # kW/K
parameters['UA3'] = [95, 15]  # kW/K

# parameters['Ts'] = [0, 0]  # C
# parameters['h1'] = [0, 0]  # kW/K
# parameters['h2'] = [0, 0]  # kW/K
# parameters['h3'] = [0, 0]  # kW/K

distrub_table1 = {}

for idx, variable in enumerate(parameters.keys()):
    distrub_table1[40*idx+10] = [(variable, 1.)]
    distrub_table1[40*idx+20] = [(variable, -1.)]
    distrub_table1[40*idx+30] = [(variable, 0.)]


distrub_table2 = {}

#
# keys = list(parameters.keys())
# rev_keys = keys.copy()
# rev_keys.reverse()
#
# for idx in range(500):
#     distrub_table2[idx] = [(keys[int(str(hash(idx))[-2:]) % len(keys)], 0.2*(idx % 5)),
#                            (rev_keys[int(str(hash(idx+3))[-2:]) % len(keys)], -0.2*(idx % 5))]

train_data = f'optimal_u\\datasets\\test_u_prediction{2500}.csv'
distrubance_keys = list(parameters.keys())
data = load_data(train_data)

for idx in range(500):
    nearest = int(idx/10)*10
    step = idx%10
    next = int((idx+10)/10)*10

    current_d = data['d'].iloc[nearest].to_numpy()
    next_d = data['d'].iloc[next].to_numpy()

    interpolated_d = current_d * (1 - step/10) + next_d * (step / 10)

    # print(current_d)
    # print(interpolated_d)
    # print(next_d)

    key_ampltiude = [(k, (v - parameters[k][0])/parameters[k][1]) for k,v in zip(distrubance_keys, interpolated_d)]

    distrub_table2[idx] = key_ampltiude

constrained_distrub_table2 = {}
train_data = f'optimal_u_constrained\\datasets\\train_u_constrained_prediction{2500}.csv'
distrubance_keys = list(parameters.keys())
data = load_data(train_data)

for idx in range(500):
    nearest = int(idx/10)*10
    step = idx%10
    next = int((idx+10)/10)*10

    current_d = data['d'].iloc[nearest].to_numpy()
    next_d = data['d'].iloc[next].to_numpy()

    interpolated_d = current_d * (1 - step/10) + next_d * (step / 10)

    # print(current_d)
    # print(interpolated_d)
    # print(next_d)

    key_ampltiude = [(k, (v - parameters[k][0])/parameters[k][1]) for k,v in zip(distrubance_keys, interpolated_d)]

    constrained_distrub_table2[idx] = key_ampltiude


